unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OmegaTimer, OmegaFont, OmegaInput, OmegaImageList, OmegaScreen,
  OmegaSprite;
const
  //Swiat warswty ZEROWEJ
  //tylko fragment- to powinno byc wczytane z edytora map
  swiat:array[0..99]of integer=
   (
    2,2,0,0,0,2, 0,0,0,0,
   0,0,2,0,0,2,-1,0,0,0,
    0,0,2,0,2,-1,0,0,0,0,
   0,0,0,2,2,-1,0,0,0,0,
    0,0,0,2,-1,0,0,0,0,0,
   0,0,0,2, 2,0,0,0,4,0,
    0,0,2,-1,2,0,0,4,4,0,
   0,0,2,-1,0,2,0,4,4,4,
    0,2,-1,0,0,2,4,0,4,0,
   0,2,-1,0,0,0,2,0,0,0
   );
  //tylko fragment- to powinno byc wczytane z edytora map
  SwiatWarstwyPierwszej:array[0..99]of integer=
   (
    -1,-1,-1,-1,-1,-1, -1,-1,-1,-1,
   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
    -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
    -1,-1,-1,-1, 1,-1,-1,-1,-1,-1,
   -1,-1,-1,-1,-1, 1,-1,-1,-1, 0,
    -1,-1,-1,-1,-1, 1,-1,-1,-1,-1,
   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
    -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1
   );
type
  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaInput1: TOmegaInput;
    OmegaFont1: TOmegaFont;
    OmegaTimer1: TOmegaTimer;
    OmegaSprite1: TOmegaSprite;
    OmegaImageList1: TOmegaImageList;
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OmegaScreen1Init(Sender: TObject);
  private
    { Private declarations }
    procedure RuchWSwiecie;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  
implementation
uses Warstwa, startoweUnit2;
{$R *.DFM}
procedure TForm1.RuchWSwiecie;
begin

 if oisLeft  in OmegaInput1.Keyboard.States then begin SkokX:=OmegaTimer1.DeltaSecs*150;end;
 if oisRight in OmegaInput1.Keyboard.States then begin SkokX:=-OmegaTimer1.DeltaSecs*150;end;
 if oisDown  in OmegaInput1.Keyboard.States then begin SkokY:=-OmegaTimer1.DeltaSecs*100;end;
 if oisUp    in OmegaInput1.Keyboard.States then begin SkokY:=OmegaTimer1.DeltaSecs*100;end;

 RogSwiata.x:=RogSwiata.x+skokX;
 RogSwiata.y:=RogSwiata.y+skokY;

 RogSwiata.kolumna:=Round(rogSwiata.x) div DaneMapy.W1Kosc;
 RogSwiata.wiersz :=Round(rogSwiata.y) div DaneMapy.H1Kosc;
 RogSwiata.Indeks:=RogSwiata.kolumna
                 + RogSwiata.wiersz*DaneMapy.XCount;

end;

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
begin
 OmegaInput1.Update;
 if not omegascreen1.CanDraw then exit;
 OmegaScreen1.ClearScreen(0,0,0,0);
 OmegaScreen1.BeginRender;

 RuchWSwiecie;


 OmegaSprite1.Collision;
 OmegaSprite1.Dead;
 OmegaSprite1.Move(OmegaTimer1.DeltaSecs);
 OmegaSprite1.Draw;

 OmegaFont1.Print(0,0,'FPS: '+IntToStr(OmegaTimer1.FPS));
 OmegaFont1.Print(0,40,Format('Indeks %dRogX %f ; RogY %f',[RogSwiata.Indeks,RogSwiata.X,RogSwiata.Y]));
 OmegaScreen1.EndRender;

 skokX:=0;
 skokY:=0;

end;

procedure TForm1.FormCreate(Sender: TObject);
var
  AMapa:PMapa;
  a,b,i:integer;
begin
  Lista:=Tlist.Create;
  New(AMapa);
  Lista.Add(AMapa);
  TworzMApeWarstwy(1,DaneMApy.XCount,DaneMapy.YCount, 0,AMapa);//zeruj aby rysowana byla siatka- klatka puste
  //zaladuj przykladowy statyczny uklad kafli do warswty pierwszej
  b:=0;a:=0;
  for i:=0 to 99 do
  begin
     AMapa^[a+b*DAneMapy.XCount].idKlatka:=swiat[i];
     inc(a);
     if i mod 10 =0 then begin b:=b+1;a:=0;end;
  end;
  //teraz mapa warswty pierwszej
  New(AMapa);
  Lista.Add(AMapa);
  TworzMApeWarstwy(0,DaneMApy.XCount,DaneMapy.YCount, -1,AMapa);//wczytaj -1 aby nic nie rysowa
  //zaladuj przykladowy statyczny uklad kafli do warswty pierwszej
  b:=0;a:=0;
  for i:=0 to 99 do
  begin
     AMapa^[a+b*DAneMapy.XCount].idObrazka:=2;//odpowiada indeksowi obrazu szafy
     AMapa^[a+b*DAneMapy.XCount].idKlatka:=SwiatWarstwyPierwszej[i];//aduj klatk z mapy
     AMapa^[a+b*DAneMapy.XCount].TileWidth:=OmegaImageList1.ImageList.Items[2].TileWidth;
     AMapa^[a+b*DAneMapy.XCount].TileHeight:=OmegaImageList1.ImageList.Items[2].TileHeight;
     //umieszcaj stope obrau w gornym lewym rogu klatki mapy
     AMapa^[a+b*DAneMapy.XCount].Left:=0;
     AMapa^[a+b*DAneMapy.XCount].Top :=(DaneMapy.H1Kosc -AMapa^[a+b*DAneMapy.XCount].TileHeight);
     inc(a);
     if i mod 10 =0 then begin b:=b+1;a:=0;end;
  end;

  OmegaScreen1.Width  :=DaneMapy.Rozdzielczosc.x;
  OmegaScreen1.Height :=DaneMapy.Rozdzielczosc.y;
  OmegaScreen1.VSYNC  :=DaneMapy.VSYNC;
  OmegaScreen1.Init;
  OmegaScreen1.SetHWnd(self.handle);
  OmegaFont1.Init;
  OmegaFont1.CreateFont('Arial',8,[]);
  OmegaFont1.Color:=OmegaColor(0,255,0);
  skokX:=0;
  skokY:=0;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i:integer;
begin
  OmegaTimer1.Enabled:=false;
  OmegaSprite1.Dead;
  OmegaScreen1.FreeOnRelease;
  if OmegaScreen1.FullScreen then  OmegaScreen1.ToggleFullScreen;
  for i:=0 to Lista.Count-1 do
  Dispose(Pmapa(Lista.Items[i]));
  Lista.Free;
  Form2.Show;

end;

procedure TForm1.FormShow(Sender: TObject);
begin
 OmegaTimer1.Enabled:=true;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=27 then close;
end;

procedure TForm1.OmegaScreen1Init(Sender: TObject);
var
  z0,//przesuniecie gebi
  a,b,dy,dx:integer;
begin
    OmegaScreen1.bpp:=DAneMapy.bpp;

    DaneMapy.OmegaSprite:=OmegaSprite1;
    DaneMapy.ImageListItem:=OmegaImageList1.ImageList.Items[0];

    skokX:=0;
    skokY:=0;

    DaneMapy.W1polKosc:=DaneMapy.W1Kosc div 2;
    DaneMapy.H1polKosc:=DaneMapy.H1Kosc div 2;

    DaneMapy.typ:=izometryczny;
    DAneMapy.OmegaImageList:=OmegaImageList1;

    DAneMapy.XSwiataEkranu:=Round(DAneMapy.Rozdzielczosc.X/DAneMapy.W1Kosc)+3;
    DAneMapy.YSwiataEkranu:=Round(DAneMapy.Rozdzielczosc.Y/DAneMapy.H1PolKosc)+3;
  dy:=0;
  dx:=0;

  RogSwiata.x:=-DaneMapy.W1Kosc;//przesun w lewo
  RogSwiata.y:=-DaneMapy.H1Kosc;//i w gre

  RogSwiata.kolumna:=0;
  RogSwiata.wiersz:=0;

  for b:=0 to DaneMapy.YSwiataEkranu-1 do
   for a:=0 to DAneMapy.XSwiataEkranu-1 do
     begin
       //to pasuje upchac do uniwersalnej procedury
       //poczatek tworzenia warstwy ZEROWEJ
       z0:=0;
       with TKostkaMapy.Create(OmegaSprite1) do
       begin
       fSiatka:=DAneMapy.fSiatka;
       Image  := DAneMapy.OmegaImageList.ImageList.Find('podloga');
       idWskMApy:=0;//zerow jest indeksem mapy warstwy 0 czyli gruntu
       ImageIndex:=PMapa(Lista.Items[idWskMApy])^[RogSwiata.Kolumna+a+b*DaneMapy.XCount].idKlatka;//0;//tablica[RogX+a+b*Dane.XCount].idKlatka;
       indeks:=RogSwiata.wiersz+a+b*DaneMapy.XCount; //pole mapy swiata
       //Image.Name:=nazwa;
       Width  := DaneMapy.W1Kosc;
       Height := DaneMapy.H1Kosc;
       image.TileWidth:=DaneMapy.W1Kosc;
       image.Tileheight:=DaneMapy.H1Kosc;

       kolumna:=a;
       wiersz:=b;
       RogX:=RogSwiata.kolumna+a;
       RogY:=RogSwiata.wiersz+b;

       x0:=dx+a*daneMapy.W1Kosc +RogSwiata.x;//przesun o poczatkowe polozenie rogu swiata
       y0:=b*DaneMapy.H1polKosc+RogSwiata.y;//przesun o poczatkowe polozenie rogu swiata
       DoCollision := false;
       DoPixelCheck := false;
       //glebia dla izometrycznej mapy odpowiada kolejnemu numerowi wiersza
       z:=b+z0;
       typ:=izometryczny;
       if b mod 2=0 then dx:=0 else
          dx:=DaneMapy.W1polKosc;
       ZmianaKlatki;
      end;//koniec with- Robienia Kosci warstwy ZEROWEJ
       //poczatek tworzenia warstwy PIERWSZEJ
       z0:=2;//zwieks zgebie warswty pierwszej
       with TKostkaMapy.Create(OmegaSprite1) do
       begin
       fSiatka:=DAneMapy.fSiatka;
       Image  := DAneMapy.OmegaImageList.ImageList.Find('szafy');//tu powinien byc podany indeks obrazu pobrany z edytora map
       idWskMApy:=1;//1 jest indeksem mapy warstwy 1 czyli scian,budynkow itp
       ImageIndex:=PMapa(Lista.Items[idWskMApy])^[RogSwiata.Kolumna+a+b*DaneMapy.XCount].idKlatka;//0;//tablica[RogX+a+b*Dane.XCount].idKlatka;
       indeks:=RogSwiata.wiersz+a+b*DaneMapy.XCount; //pole mapy swiata

       Width  := DaneMapy.W1Kosc;
       Height := DaneMapy.H1Kosc;

       kolumna:=a;
       wiersz:=b;
       RogX:=RogSwiata.kolumna+a;
       RogY:=RogSwiata.wiersz+b;

       x0:=dx+a*daneMapy.W1Kosc +RogSwiata.x;//przesun o poczatkowe polozenie rogu swiata
       y0:=b*DaneMapy.H1polKosc+RogSwiata.y;//przesun o poczatkowe polozenie rogu swiata
       DoCollision := false;
       DoPixelCheck := false;
       //glebia dla izometrycznej mapy odpowiada kolejnemu numerowi wiersza
       z:=b+z0;
       typ:=izometryczny;
       if b mod 2=0 then dx:=0 else
          dx:=DaneMapy.W1polKosc;
       //uaktualnij :Width.Height,TileWidth,TileHeight
       ZmianaKlatki;
      end;//koniec with- Robienia Kosci warstwy PIERWSZEJ
   end;
end;

end.
